// TodayItem.cpp: implementation of the CTodayItem class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "resource.h"
#include "TodayItem.h"

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CTodayItem::CTodayItem(HINSTANCE hInstance)
	: CTodayWindow()
{
	SetInstance(hInstance);
	SetIcon(IDI_APP_ICON);
	SetItemHeight(40);
	SetClassInfo(_T("MyToday2WndClass"), _T("MyToday2Wnd"));
	UnregisterTodayClass();

	m_hPowerIcon = LoadIcon(m_hInstance, MAKEINTRESOURCE(IDI_POWER_ICON));

	m_bShowFirst = TRUE;
	m_bShowSecond = TRUE;
	m_bShowPower = TRUE;
}

CTodayItem::~CTodayItem()
{
	if (m_hPowerIcon)
		DestroyIcon(m_hPowerIcon);

	CTodayWindow::~CTodayWindow();
}

//////////////////////////////////////////////////////////////////////
// Message handlers
//////////////////////////////////////////////////////////////////////
void CTodayItem::OnLButtonUp(UINT nFlags, POINT point)
{
	if (m_bShowPower)
	{
		RECT rect;
		rect.left = 200;
		rect.top = 2;
		rect.right = rect.left + 32;
		rect.bottom = rect.top + 32;

		if (PtInRect(&rect, point))
		{
			// Click on power icon runs Power control panel applet
			PROCESS_INFORMATION pi;

			::CreateProcess(_T("\\Windows\\ctlpnl.exe"), _T("cplmain.cpl,3"), NULL, NULL, FALSE, 0, NULL, NULL, NULL, &pi);
			return;
		}
	}
}

void CTodayItem::OnPaint(HDC hDC)
{
	HFONT hFontOld;
	RECT rect;
	SIZE size;
	LPCTSTR szText;

	SetBkColor(hDC, TRANSPARENT);
	SetTextColor(hDC, m_crTodayText);

	// First draw text using bold today font
	if (m_bShowFirst)
	{
		szText = _T("First line - bold font");

		hFontOld = (HFONT)SelectObject(hDC, m_fontTodayBold);

		GetTextExtentPoint32(hDC, szText, _tcslen(szText), &size);
		rect.left = 30;
		rect.top = 0;
		rect.right = rect.left + size.cx;
		rect.bottom = size.cy;

		DrawText(hDC, szText, -1, &rect, DT_LEFT);

		SelectObject(hDC, hFontOld);
	}

	// Then draw text using normal today font
	if (m_bShowSecond)
	{
		szText = _T("Second line - normal font");
		hFontOld = (HFONT)SelectObject(hDC, m_fontTodayNormal);

		GetTextExtentPoint32(hDC, szText, _tcslen(szText), &size);
		rect.left = 30;
		rect.top = 15;
		rect.right = rect.left + size.cx;
		rect.bottom = rect.top + size.cy;

		DrawText(hDC, szText, -1, &rect, DT_LEFT);

		SelectObject(hDC, hFontOld);
	}

	if (m_hPowerIcon && m_bShowPower)
		DrawIcon(hDC, 200, 2, m_hPowerIcon);
}
